/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.HisatuacaoRecord;

import java.sql.Date;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Hisatuacao extends TableImpl<HisatuacaoRecord> {

    private static final long serialVersionUID = -1389632288;

    /**
     * The reference instance of <code>public.hisatuacao</code>
     */
    public static final Hisatuacao HISATUACAO = new Hisatuacao();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<HisatuacaoRecord> getRecordType() {
        return HisatuacaoRecord.class;
    }

    /**
     * The column <code>public.hisatuacao.histatuaid</code>.
     */
    public final TableField<HisatuacaoRecord, Integer> HISTATUAID = createField("histatuaid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('hisatuacao_histatuaid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.hisatuacao.fkardid</code>.
     */
    public final TableField<HisatuacaoRecord, Integer> FKARDID = createField("fkardid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.hisatuacao.fktanid</code>.
     */
    public final TableField<HisatuacaoRecord, Integer> FKTANID = createField("fktanid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.hisatuacao.fkatuid</code>.
     */
    public final TableField<HisatuacaoRecord, Integer> FKATUID = createField("fkatuid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.hisatuacao.fkempid</code>.
     */
    public final TableField<HisatuacaoRecord, Integer> FKEMPID = createField("fkempid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.hisatuacao.hora</code>.
     */
    public final TableField<HisatuacaoRecord, String> HORA = createField("hora", org.jooq.impl.SQLDataType.VARCHAR(50).defaultValue(org.jooq.impl.DSL.field("CURRENT_TIME", org.jooq.impl.SQLDataType.VARCHAR)), this, "");

    /**
     * The column <code>public.hisatuacao.dia</code>.
     */
    public final TableField<HisatuacaoRecord, Date> DIA = createField("dia", org.jooq.impl.SQLDataType.DATE.defaultValue(org.jooq.impl.DSL.field("CURRENT_DATE", org.jooq.impl.SQLDataType.DATE)), this, "");

    /**
     * The column <code>public.hisatuacao.medida</code>.
     */
    public final TableField<HisatuacaoRecord, String> MEDIDA = createField("medida", org.jooq.impl.SQLDataType.VARCHAR(50), this, "");

    /**
     * Create a <code>public.hisatuacao</code> table reference
     */
    public Hisatuacao() {
        this(DSL.name("hisatuacao"), null);
    }

    /**
     * Create an aliased <code>public.hisatuacao</code> table reference
     */
    public Hisatuacao(String alias) {
        this(DSL.name(alias), HISATUACAO);
    }

    /**
     * Create an aliased <code>public.hisatuacao</code> table reference
     */
    public Hisatuacao(Name alias) {
        this(alias, HISATUACAO);
    }

    private Hisatuacao(Name alias, Table<HisatuacaoRecord> aliased) {
        this(alias, aliased, null);
    }

    private Hisatuacao(Name alias, Table<HisatuacaoRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.HISATUACAO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<HisatuacaoRecord, Integer> getIdentity() {
        return Keys.IDENTITY_HISATUACAO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<HisatuacaoRecord> getPrimaryKey() {
        return Keys.HISATUACAO_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<HisatuacaoRecord>> getKeys() {
        return Arrays.<UniqueKey<HisatuacaoRecord>>asList(Keys.HISATUACAO_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<HisatuacaoRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<HisatuacaoRecord, ?>>asList(Keys.HISATUACAO__HISATUACAO_FKARDID_FKEY, Keys.HISATUACAO__HISATUACAO_FKTANID_FKEY, Keys.HISATUACAO__HISATUACAO_FKATUID_FKEY, Keys.HISATUACAO__HISATUACAO_FKEMPID_FKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Hisatuacao as(String alias) {
        return new Hisatuacao(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Hisatuacao as(Name alias) {
        return new Hisatuacao(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Hisatuacao rename(String name) {
        return new Hisatuacao(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Hisatuacao rename(Name name) {
        return new Hisatuacao(name, null);
    }
}
